#include <avr/eeprom.h> 
#include <string.h>
#include "hd44780.h"

#define ODD_OR_EVEN_TEXT_LENGTH 5

uint16_t EEMEM ee_num_executions;
uint8_t EEMEM ee_odd_or_even;
char EEMEM ee_odd_or_even_string[ODD_OR_EVEN_TEXT_LENGTH];

int main (void)
{
    lcd_init();

	uint16_t num_executions = eeprom_read_word(&ee_num_executions);
	if (num_executions==0xFFFF)
		num_executions=0;
	num_executions++;
	eeprom_write_word(&ee_num_executions,num_executions);

	uint8_t odd_or_even = eeprom_read_byte(&ee_odd_or_even);
	if (odd_or_even==0xFF)
		odd_or_even=num_executions % 2;
	else
		odd_or_even = !odd_or_even;
	eeprom_write_byte(&ee_odd_or_even,odd_or_even);

	char odd_or_even_string[ODD_OR_EVEN_TEXT_LENGTH];
	eeprom_read_block((void*)&odd_or_even_string, (const void*)&ee_odd_or_even_string, ODD_OR_EVEN_TEXT_LENGTH);
	char ff_string[5]={0xFF,0xFF,0xFF,0xFF,0xFF};
	if (!strncmp(odd_or_even_string,ff_string,ODD_OR_EVEN_TEXT_LENGTH))
		strcpy(odd_or_even_string,"Odd");
	else if (strcmp(odd_or_even_string,"Even"))
		strcpy(odd_or_even_string,"Even");
	else
		strcpy(odd_or_even_string,"Odd");
	eeprom_write_block ((void*)&odd_or_even_string, (const void*)&ee_odd_or_even_string, ODD_OR_EVEN_TEXT_LENGTH);
    
    lcd_clrscr();
	char buffer[16];
	sprintf(buffer,"%d Executions", num_executions);
	lcd_puts(buffer);
	lcd_goto(40);
	sprintf(buffer,"%d %s", odd_or_even, odd_or_even_string);
	lcd_puts(buffer);

    return(0);
}
